--- textutils-2.0.17/lib/physmem.c.mem	Fri Nov 16 10:18:07 2001
+++ textutils-2.0.17/lib/physmem.c	Fri Nov 23 16:40:10 2001
@@ -31,6 +31,14 @@
 # include <sys/pstat.h>
 #endif
 
+/* Cap physical memory to something sane */
+static double
+physmem_cap (double mem)
+{
+  double max = 1 << (sizeof(void *)*8 - 4);
+  return mem > max ? max : mem;
+}
+
 /* Return the total amount of physical memory.  */
 double
 physmem_total (void)
@@ -40,7 +48,7 @@
     double pages = sysconf (_SC_PHYS_PAGES);
     double pagesize = sysconf (_SC_PAGESIZE);
     if (0 <= pages && 0 <= pagesize)
-      return pages * pagesize;
+      return physmem_cap(pages * pagesize);
   }
 #endif
 
@@ -84,7 +92,7 @@
 	double pages = psd.psd_free;
 	double pagesize = pss.page_size;
 	if (0 <= pages && 0 <= pagesize)
-	  return pages * pagesize;
+	  return physmem_cap(pages * pagesize);
       }
   }
 #endif
